

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_MINIMIZATIONATTENUATION_H
#define ADORE_MINIMIZATIONATTENUATION_H

#include <adrcore/util/mathutil.h>

namespace adore
{

	namespace core
	{

		/**
			 
		*/

		inline void huberVector( AVector &argument, double thresh )
		{
			double threshSqr = thresh * thresh;
			double normArg = getSqrNorm( argument );
			//printf("normArg: %f\n", normArg);
			if ( normArg > threshSqr )
			{
				double normArgSqrt = sqrt( normArg );
				double w = sqrt( 2 * thresh * normArgSqrt - threshSqr ) / normArgSqrt;
				argument = argument * w;
			}
		}

		inline void huberScalar( AVector &argument, double thresh )
		{
			double threshSqr = thresh * thresh;
			for ( int row = 0; row < (int)argument.rows(); ++row )
			{
				double arg = argument( row );
				double normArg = arg * arg;
				if ( normArg > threshSqr )
				{
					double w = sqrt( 2 * thresh * fabs( arg ) - threshSqr ) / arg;
					argument( row ) = w * arg;
				}
			}
		}


		inline void blakeZissVector( AVector & argument, double thresh )
		{
			double threshSqr = thresh * thresh;
			double normArg = getSqrNorm( argument );
			double w = -log(exp(-normArg) + threshSqr);
			argument = argument * w;
		}

	}

}

#endif
