

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_MINIMIZATIONDEFAULTERRORFUNC2_H
#define ADORE_MINIMIZATIONDEFAULTERRORFUNC2_H

#include <adrcore/types/aarray.h>

namespace adore
{

	namespace core
	{

		/**
			 
		*/
		template<class T_numtype>
		class DefaultErrorFunc2
		{
			public:
				DefaultErrorFunc2( AArray<T_numtype, 1> &goal ):g( goal )
				{
					;
				}

				void operator()( const AArray<T_numtype, 1> &val, AArray<T_numtype, 1> &result ) const
				{
					val.sub2( g, result );
				}

			private:
				AArray<T_numtype, 1> &g;
		};

		template<class T_numtype>
		class ZeroErrorFunc2
		{
			public:
				void operator()( const AArray<T_numtype, 1> &val, AArray<T_numtype, 1> &result ) const
				{
					result = val;
				}
		};


	}

}

#endif
