

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#include "cameraminfunc.h"
#include <adrcore/util/matmul2.h>

namespace adore
{
	namespace core
	{

		CameraMinFunc::CameraMinFunc():
				pts3D( NULL )
		{
		}


		CameraMinFunc::~CameraMinFunc()
		{
		}

		void CameraMinFunc::operator()( const AVector &camera, AVector& diff ) const
		{
			assert( pts3D );
//			AVector diff( 2 * pts3D->size() );

			int idx = 0;
			for ( uint i = 0; i < pts3D->size(); ++i )
			{
				AVector &pt = *( *pts3D )[i];
				double w = camera( 8 ) * pt( 0 ) + camera( 9 ) * pt( 1 ) + camera( 10 ) * pt( 2 ) + camera( 11 ) * pt( 3 );
				double x = camera( 0 ) * pt( 0 ) + camera( 1 ) * pt( 1 ) + camera( 2 )  * pt( 2 ) + camera( 3 )  * pt( 3 );
				double y = camera( 4 ) * pt( 0 ) + camera( 5 ) * pt( 1 ) + camera( 6 )  * pt( 2 ) + camera( 7 )  * pt( 3 );
				diff( idx++ ) = x / w;
				diff( idx++ ) = y / w;
			}

//			return diff;
		}


	}
}
