

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_HOMOGRAPHYCALCULATOR_H
#define ADORE_HOMOGRAPHYCALCULATOR_H

#include <adrcore/types/aarray.h>

#include <vector>
using std::vector;

namespace adore {
	namespace core {

		class HomographyCalculator
		{

		public:

			HomographyCalculator() {}

			/**
			 * one-View overlap, algebraic error, points do only fix 4 degrees of freedom.
			 * Three points are the minimum.
			 */
			AMatrix calculateHomographyAlgebraic ( const AMatrix & cam1, const AMatrix & cam2, const vector< AVector* > & pts3D1, const vector< AVector* > & pts3D2 );


			bool calculateAssumingMetricUsePoints ( const AMatrix & cam1, const AMatrix & cam2, const vector< AVector* > & pts1, const vector< AVector* > & pts2, AMatrix& H);
			bool calculateAssumingMetricUseAll ( const AMatrix & cam1, const AMatrix & cam2, const vector< AVector* > & pts1, const vector< AVector* > & pts2, AMatrix& H);
			AMatrix calculateFromPointsMetric ( const vector< AVector* > & pts1, const vector< AVector* > & pts2);
		};
	} // core
} // adore

#endif // ADORE_HOMOGRAPHYCALCULATOR_H
