

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#include "point3dcorrfunc.h"

namespace adore
{
	namespace core
	{

		Point3DCorrFunc::Point3DCorrFunc( vector<Camera *> *cams ):
				camvec( NULL )
		{
			if ( cams ) setCams( cams );
		}


		Point3DCorrFunc::~Point3DCorrFunc()
		{
		}

		void Point3DCorrFunc::operator()( const AVector &pt, AVector& result ) const
		{
			int resultIdx = 0;
//			AVector result( 2 * camvec->size() );

			for ( uint i = 0; i < camvec->size(); ++i )
			{
				AMatrix &camera = ( *camvec )[i]->getProjMat();
				double w = camera( 2, 0 ) * pt( 0 ) + camera( 2, 1 ) * pt( 1 ) + camera( 2, 2 ) + camera( 2, 3 ) * pt( 2 );
				double x = camera( 0, 0 ) * pt( 0 ) + camera( 0, 1 ) * pt( 1 ) + camera( 0, 2 ) + camera( 0, 3 ) * pt( 2 );
				double y = camera( 1, 0 ) * pt( 0 ) + camera( 1, 1 ) * pt( 1 ) + camera( 1, 2 ) + camera( 1, 3 ) * pt( 2 );

				result( resultIdx++ ) = x / w;
				result( resultIdx++ ) = y / w;
			}
//			return result;
		}

	}
}
