

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef PERSISTENCE_BOOST_FEATURELINE_H
#define PERSISTENCE_BOOST_FEATURELINE_H

#include <adrcore/types/featureline.h>

#include <adrcore/persistence/boost/aarray.h>

namespace boost
{
	namespace serialization
	{
		using namespace adore::core;

		template<typename Archive>
		void save( Archive & ar, const FeatureLine& line, unsigned int version )
		{
			ar << ( const int& )line.getId();
			ar << line.getPt1();
			ar << line.getPt2();
		}

		template<typename Archive>
		void load( Archive & ar, FeatureLine& line, unsigned int version )
		{
			int id; ar >> id; line.setId( id );
			ar >> line.getPt1();
			ar >> line.getPt2();
		}

		template<typename Archive>
		inline void serialize( Archive & ar, FeatureLine& l, const unsigned int file_version )
		{
			split_free( ar, l, file_version );
		}
	}
}

#endif // PERSISTENCE_BOOST_FEATURELINE_H
