

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef ZINBUF_H
#define ZINBUF_H

#include <streambuf>
#include <cstdio>

namespace zstream
{

	using namespace std;

	class zinbuf : public streambuf
	{
		public:
			zinbuf();
			virtual ~zinbuf();

			void open( const char* name );
			bool is_open()const;
			zinbuf* close();

		protected:
			virtual int_type underflow();

			virtual pos_type seekoff( off_type offset, std::ios_base::seekdir dir, std::ios_base::openmode );
			virtual pos_type seekpos( pos_type sp, std::ios_base::openmode );

		private:
			static const int buf_size = 65536;
			char buffer[buf_size];

			int lastError;
			void* file;
	};

} //zstream

#endif // ZINBUF_H
