

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_RANDOMPROSAC_H
#define ADORE_RANDOMPROSAC_H

#include <vector>
#include <set>
#include <adrcore/util/mathutil.h>
#include <adrcore/util/debug.h>
#include <adrcore/random/integerrandomset.h>
#include <adrcore/random/ransacclient.h>
#include <adrcore/random/ransacparams.h>

namespace adore
{
	namespace core
	{

		using namespace std;

		/**
		 * A RANSAC filter.
		 * This is an abstract class. If you want to filter point correspondences using a RANSAC technique, feel free to derive.
		 * There are three methods you will have to implement (see below).
		 * Do not override the filter function!
		 *  
		*/
		class PROSAC
		{
			public:

				void operator()( RANSACClient *client, const RansacParams params );

		};

	}
}

#endif
