

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Andrei Tchouev


#ifndef ADORE_SURFACE_DELAUNAY_H
#define ADORE_SURFACE_DELAUNAY_H

namespace adore
{
	namespace core
	{
		/**	Simplex callback function.
		*	This function will be called every time a new simplex
		*	is added to triangulation.
		*	@param v Indices of the vertices of triangle
		*	@param extra Additional parameter that is provided by the triangulating function
		*/
		typedef void ( *addsimplex )( unsigned* v, void* extra );

		/**	Calculate 2D Delaunay triangulation using D&C DeWall algorithm.
		*	@param points Array of points' coordinates
		*	@param count Number of source points
		*	@param receiver Triangle callback function
		*	@param extra Additional parameter that is given to the simplex callback function
		*
		*	 
		*/
		void delaunay2( double* points, unsigned count, addsimplex receiver, void* extra );

		/**	Calculate 3D Delaunay triangulation using D&C DeWall algorithm.
		*	@param points Array of points' coordinates
		*	@param count Number of source points
		*	@param receiver Triangle callback function
		*	@param extra Additional parameter that is given to the simplex callback function
		*
		*	 
		*/
		void delaunay3( double* points, unsigned count, addsimplex receiver, void* extra );
	}
}

#endif	//ADORE_SURFACE_DELAUNAY_H
