

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef ADORE_AARRAYRANGE_H
#define ADORE_AARRAYRANGE_H

#include <boost/multi_array.hpp>

namespace adore {
    namespace core {

        class Range {
            bool m_all;
            int m_begin, m_end;
            Range() : m_all(true), m_begin(-1), m_end(-1) {}

            typedef boost::multi_array_types::index_range range_type;

        public:
            static Range all() { return Range(); }
            explicit Range(int i0, int i1) : m_all(false), m_begin(i0), m_end(i1) {}

            operator range_type() const
            {
                if(m_all) return range_type();
                else return range_type(m_begin, m_end + 1);
            }
        };

    } // core
} // adore

#endif // ADORE_AARRAYRANGE_H
