

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef ADORE_FEATURELINE_H
#define ADORE_FEATURELINE_H

#include <adrcore/types/feature.h>
#include <adrcore/types/aarray.h>

namespace adore
{
	namespace core
	{
		class FeatureLine : public Feature
		{
				AVector pt1, pt2;
			public:
				FeatureLine( int typeID = 0 ) :
						Feature( typeID ),
						pt1( 3 ), pt2( 3 )
				{}
				FeatureLine( double x1, double y1, double x2, double y2, int typeID = 0 ) :
						Feature( typeID ),
						pt1( 3 ), pt2( 3 )
				{
					pt1 = x1, y1, 1.0;
					pt2 = x2, y2, 1.0;
				}
				const AVector& getPt1() const { return pt1; }
				AVector& getPt1() { return pt1; }
				const AVector& getPt2() const { return pt2; }
				AVector& getPt2() { return pt2; }

				void transform( double addX, double addY, double scaleX, double scaleY )
				{
					pt1( 0 ) = scaleX * pt1( 0 ) + addX;
					pt1( 1 ) = scaleY * pt1( 1 ) + addY;
					pt2( 0 ) = scaleX * pt2( 0 ) + addX;
					pt2( 1 ) = scaleY * pt2( 1 ) + addY;
				}
		};
	}
}
#endif // ADORE_FEATURELINE_H

