

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_VIEWKEYSTRING_H
#define ADORE_VIEWKEYSTRING_H


#define PTR_TO_CHARS_1(Vptr) int CHARSIZE = sizeof(Vptr);\
char CHARS[CHARSIZE];\
memcpy(CHARS, &(Vptr), CHARSIZE);

#define PTR_TO_CHARS_2(Vptr1, Vptr2) int CHARSIZE = sizeof(Vptr1) + sizeof(Vptr2);\
char CHARS[CHARSIZE];\
memcpy(CHARS, &Vptr1, sizeof(Vptr1));\
memcpy(&CHARS[sizeof(Vptr1)], &Vptr2, sizeof(Vptr2));

#define PTR_TO_CHARS_3(Vptr1, Vptr2, Vptr3) int CHARSIZE = sizeof(Vptr1) + sizeof(Vptr2) + sizeof(Vptr3);\
char CHARS[CHARSIZE];\
memcpy(CHARS, &Vptr1, sizeof(Vptr1));\
memcpy(&CHARS[sizeof(Vptr1)], &Vptr2, sizeof(Vptr2));\
memcpy(&CHARS[sizeof(Vptr1) + sizeof(Vptr2)], &Vptr3, sizeof(Vptr3));

#define PTR_TO_CHARS_4(Vptr1, Vptr2, Vptr3, Vptr4) int CHARSIZE = sizeof(Vptr1) + sizeof(Vptr2) + sizeof(Vptr3) + sizeof(Vptr4);\
char CHARS[CHARSIZE];\
memcpy(CHARS, &Vptr1, sizeof(Vptr1));\
memcpy(&CHARS[sizeof(Vptr1)], &Vptr2, sizeof(Vptr2));\
memcpy(&CHARS[sizeof(Vptr1) + sizeof(Vptr2)], &Vptr3, sizeof(Vptr3));\
memcpy(&CHARS[sizeof(Vptr1) + sizeof(Vptr2) + sizeof(Vptr3)], &Vptr4, sizeof(Vptr4));

namespace adore
{
	namespace core
	{

		typedef basic_string<char> ViewsKeyString;

		inline ViewsKeyString getKey( ViewBase * v1 )
		{
			PTR_TO_CHARS_1( v1 );
			ViewsKeyString key( CHARS, CHARSIZE );
			return key;
		}

		inline ViewsKeyString getKey( ViewBase * v1, ViewBase * v2 )
		{
			PTR_TO_CHARS_2( v1, v2 );
			ViewsKeyString key( CHARS, CHARSIZE );
			return key;
		}

		inline ViewsKeyString getKey( ViewBase * v1, ViewBase * v2, ViewBase * v3 )
		{
			PTR_TO_CHARS_3( v1, v2, v3 );
			ViewsKeyString key( CHARS, CHARSIZE );
			return key;
		}

		inline ViewsKeyString getKey( ViewBase * v1, ViewBase * v2, ViewBase * v3, ViewBase * v4 )
		{
			PTR_TO_CHARS_4( v1, v2, v3, v4 );
			ViewsKeyString key( CHARS, CHARSIZE );
			return key;
		}

		template<class IteratorT> inline ViewsKeyString getKey( IteratorT begin, IteratorT end )
		{
			ViewsKeyString key;
			for ( ; begin != end; ++begin )
			{
				ViewBase *v = *begin;
				PTR_TO_CHARS_1( v );
				key.append( CHARS, CHARSIZE );
			}
			return key;
		}

	}
}

#endif

