

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_COREDIVISIONDISTORTION_H
#define ADORE_COREDIVISIONDISTORTION_H

namespace adore
{

	namespace core
	{

		/**
		 * @param x distorted x
		 * @param y distorted y
		 * @return true, if successful
		 * x and y are in the pinhole system afterwards
		 */
		template<class floaT>
		bool undistortRadial( floaT &x, floaT &y, const floaT lambda );

		/**
		 * @param x pinhole x
		 * @param y pinhole y
		 * @return true, if successful
		 * x and y are in the distorted system afterwards
		 */
		template<class floaT>
		bool distortRadial( floaT &x, floaT &y, const floaT lambda );


	}

}

#endif
