

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADOREELEMACCESS_H
#define ADOREELEMACCESS_H

//#include "unptr.h"

namespace adore
{
	namespace core
	{

		template<class T>
		class ElemAtSB/*SB = square bracket*/
		{
			public:
				typedef typename T::value_type value_type;

				inline const value_type& operator()( const T& e, const uint i ) const
				{
					return e[i];
				}

				inline value_type& operator()( T& e, const uint i ) const
				{
					return e[i];
				}
		};

		template<class T>
		class ElemAtSB<T*>/*SB = square bracket*/
		{
			public:
				typedef typename T::value_type value_type;

				inline const value_type operator()( const T* e, const uint i ) const
				{
					return ( *e )[i];
				}
		};

		template<class T>
		class ElemAtRB/*RB = round bracket*/
		{
			public:
				typedef typename T::value_type value_type;

				inline const value_type& operator()( const T& e, const uint i ) const
				{
					return e( i );
				}

				inline value_type& operator()( T& e, const uint i ) const
				{
					return e( i );
				}
		};

		template<class T>
		class ElemAtRB<T*>/*RB = round bracket*/
		{
			public:
				typedef typename T::value_type value_type;

				inline const value_type operator()( const T* e, const uint i ) const
				{
					return ( *e )( i );
				}
		};

	}
}
#endif
