

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_UTILUNPTR_H
#define ADORE_UTILUNPTR_H

#include "debug.h"

namespace adore
{

	namespace core
	{

		template <class T> struct Ptr
		{
			typedef T* type;
		};

		template <class T> struct Ptr<T*>
		{
			typedef T* type;
		};

		template <class T> struct UnPtr
		{
			typedef T type;
		};

		template <class T> struct UnPtr<T*>
		{
			typedef T type;
		};

		template <class T> struct ToValue
		{
			inline T& operator()( T & val ) {return val;}
		};

		template <class T> struct ToValue<T*>
		{
			inline T& operator()( T* val ) {return *val;}
		};

		template <class T> struct ToPointer
		{
			inline T* operator()( T & val ) {return &val;}
		};

		template <class T> struct ToPointer<T*>
		{
			inline T* operator()( T * val ) {return val;}
		};

	}
}

#endif
