

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_VIEWMATCH_DESCRIPTORCREATOR_H
#define ADORE_VIEWMATCH_DESCRIPTORCREATOR_H
#include <adrcore/types/commontypes.h>
#include <adrcore/types/nviewmap.h>
namespace adore
{
	namespace core
	{

		class DescriptorCreator
		{
			protected:
				typedef uint8_t imgT;
				typedef View<imgT> ViewT;
				uint fid,did;
			public:
				DescriptorCreator ( uint FID=0, uint DID=0 ) :fid ( FID ),did ( DID ) {;}

				virtual ~DescriptorCreator() {;}

				void performAction ( ViewT *view )
				{
					performActionDerived ( view );
				}

				void setFeatureID ( uint ID ) {fid=ID;}

                void setDescriptorID ( uint ID ) {did=ID;}

				uint getFeatureID() const {return fid;}

				uint getDescriptorID() const {return did;}

				template<class ViewIterator>
				void performAction ( ViewIterator vit, int numViews )
				{
					for ( int i = 0; i < numViews; ++i, ++vit )
					{
						ViewT *v = dynamic_cast<ViewT *> ( *vit );
						performActionDerived ( v );
					}
				}

				void performAction ( NViewMap &map )
				{
					performAction ( map.getAllViewsBegin(), map.getNumAllViews() );
				}

				virtual DescriptorCreator* clone() {error( "missing implementation\n" );}

			protected:

				virtual void performActionDerived ( ViewT *view ) =0;
		};

	}
}//ns

#endif

