

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_HARRISFINDER_H
#define ADORE_HARRISFINDER_H


#include "featurefinder.h"
#include <adrcore/imgprocessing/imageplane.h>
#include <adrcore/imgprocessing/templatematching.h>
#include <adrcore/types/featurepoint.h>
#include <adrcore/types/view.h>


namespace adore
{
	namespace core
	{

		class HarrisFinder : public FeatureFinder
		{
			private:
				typedef unsigned char imgT;
				typedef int ouT;

			private:
				uint fid;//feature id

				ViewT *v;

				ouT minStrength;
				float minDist, minFraction;
				uint harrisHood;
				int maxPoints;
				ImagePlane<ouT> gxx;
				ImagePlane<ouT> gyy;
				ImagePlane<ouT> gxy;

			protected:
				typedef View<uint8_t> ViewT;
			public:
				HarrisFinder ( uint ID, uint harrisHood = 1, float mindist = 5.0, ouT minstrength=1000,
				               float minfraction = 0.05, int maxpoints = INT_MAX );

				//callback
				void operator() ( FeaturePoint *fp )
				{
					fp->setView ( v );
					//cout<<"ID:"<<fp->getFeatureTypeId()<<endl;
//					if ( ( ( *fp ) ( 0 ) < border ) || ( ( *fp ) ( 1 ) < border ) ||
//					                ( ( *fp ) ( 0 ) > v->getWidth()-border ) || ( ( *fp ) ( 1 ) > v->getHeight()-border ) )
//					{
//						cout<<"Point dropped (border rule)"<<endl;
//						delete fp;
//						return;
//					}
					if ( v->add ( fp ) != GRID_SUCCESS )
					{
						delete fp;
						return;
					}
				}

			protected:
				unsigned int findFeaturesDerived ( ViewT *v );

			private:
				void calcDizenzo ( ImagePlane<imgT> &img );

		};
	}
}//ns

#endif
