

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_COREVIEWRELATER_H
#define ADORE_COREVIEWRELATER_H

#include <adrcore/types/nviewmap.h>

namespace adore
{

	namespace core
	{

		/**
			 
		*/
		class ViewRelater
		{
			public:
				virtual ~ViewRelater ( ) {}

				void createRelations( NViewMap &map )
				{
					ViewBase *views[map.getNumAllViews()];
					uint i = 0;	for ( NViewMap::ViewIterator it = map.getAllViewsBegin(); it != map.getAllViewsEnd(); ++it, ++i ) views[i] = *it;
					createRelations ( views, map.getNumAllViews(), map.getViewRelations() );
				}

				template<class Iterator>
				void createRelations ( Iterator vit, int numViews, ViewRelations &vrela )
				{
					ViewBase *views[numViews];
					for ( int i = 0; i < numViews; ++vit, ++i ) views[i] = *vit;
					createRelations ( views, numViews, vrela );
				}

				virtual void createRelations ( ViewBase **vit, int numViews, ViewRelations &vrela ) = 0;
		};

	}

}

#endif
