

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Andrei Tchouev


#ifndef ADORE_GLAVATAR_H
#define ADORE_GLAVATAR_H

#include "glmesh.h"

namespace adore
{
	namespace visual
	{
		class GLAvatar
		{
		public:
			/**	Create a mesh for a box with given dimensions, centered about the origin
			 *	@param dx length along the X-axis
			 *	@param dy length along the Y-axis
			 *	@param dz length along the Z-axis
			 */
			static void box(GLMesh& mesh, float dx, float dy, float dz);

			/**	Create a mesh for a regular polygon in XY plane
			 */
			static void polygon(GLMesh& mesh, unsigned sides);

			/**	Create a mesh for a tetrahedron
			 */
			static void tetrahedron(GLMesh& mesh);

			/**	Create a mesh for a camera
			 */
			static void camera(GLMesh& mesh);
		};
	}
}

#endif	// ADORE_GLAVATAR_H
