

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Andrei Tchouev


#include "gllight.h"

#include <GL/gl.h>

namespace adore
{
	namespace visual
	{
		GLLight::GLLight()
		{
			position.set(0.0f,0.0f,1.0f,0.0f);

			ambient.set(0.0f,0.0f,0.0f,1.0f);
			diffuse.set(1.0f,1.0f,1.0f,1.0f);
			specular.set(1.0f,1.0f,1.0f,1.0f);

			spot.set(0.0f,0.0f,1.0f,0.0f);
			spot_exp = 0.0f;
			spot_cutoff = 180.0f;

			att_const = 1.0f;
			att_linear = 0.0f;
			att_quad = 0.0f;

			enabled = false;
		}

		void GLLight::setOpenGLLight(int index)
		{
			assert(index>=0 && index<GL_MAX_LIGHTS);

			index += GL_LIGHT0;

			if(enabled)
			{
				glLightfv(index,GL_POSITION,position.toArray());

				glLightfv(index,GL_AMBIENT,ambient.toArray());
				glLightfv(index,GL_DIFFUSE,diffuse.toArray());
				glLightfv(index,GL_SPECULAR,specular.toArray());

				glLightfv(index,GL_SPOT_DIRECTION,spot.toArray());
				glLightf(index,GL_SPOT_EXPONENT,spot_exp);
				glLightf(index,GL_SPOT_CUTOFF,spot_cutoff);

				glLightf(index,GL_CONSTANT_ATTENUATION,att_const);
				glLightf(index,GL_LINEAR_ATTENUATION,att_linear);
				glLightf(index,GL_QUADRATIC_ATTENUATION,att_quad);

				glEnable(index);
			}
			else
				glDisable(index);
		}
	}
}
