

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef _ADORE_SELECTBROADCAST_
#define _ADORE_SELECTBROADCAST_

#include "selectlistener.h"

namespace adore
{
	namespace visual
	{

		class SelectNotifier
		{
		public:
            virtual ~SelectNotifier(){;}
			void addListener(SelectListener* listener)
            {
                listeners.push_back(listener);
            }


		protected:
			void notifyListeners(AVector3D* pt)
            {
                for(uint i = 0; i < listeners.size(); ++i)
                    listeners[i]->point3DChosen(pt);
            }
            
            void notifyListeners(Camera* pt)
            {
                for(uint i = 0; i < listeners.size(); ++i)
                    listeners[i]->cameraChosen(pt);
            }

		private:			
			std::vector<SelectListener*> listeners;
		};
	}
}
#endif	//_ADORE_SELECTBROADCAST_
