

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef CAMERAWIDGET_H
#define CAMERAWIDGET_H

#include "ui_camerawidgetbase.h"

#define ROT_ACCURACY "%.3f"
#define POS_ACCURACY "%.2f"
#define ACCURACY "%.5f"

class CameraWidget : public QWidget
{
		Q_OBJECT

	public:
		CameraWidget( QWidget* parent = 0 );
		~CameraWidget();

		void setPosX( double d )
		{
			QString s;
			s.sprintf( POS_ACCURACY, d );
			ui.posx->setText( s );
			ui.posx->setCursorPosition(0);
		}
		void setPosY( double d )
		{
			QString s;
			s.sprintf( POS_ACCURACY, d );
			ui.posy->setText( s );
			ui.posy->setCursorPosition(0);
		}
		void setPosZ( double d )
		{
			QString s;
			s.sprintf( POS_ACCURACY, d );
			ui.posz->setText( s );
			ui.posz->setCursorPosition(0);
		}
		void setRotX( double d )
		{
			QString s;
			s.sprintf( ROT_ACCURACY, d );
			ui.rx->setText( s );
			ui.rx->setCursorPosition(0);
		}
		void setRotY( double d )
		{
			QString s;
			s.sprintf( ROT_ACCURACY, d );
			ui.ry->setText( s );
			ui.ry->setCursorPosition(0);
		}
		void setRotZ( double d )
		{
			QString s;
			s.sprintf( ROT_ACCURACY, d );
			ui.rz->setText( s );
			ui.rz->setCursorPosition(0);
		}
		void setAngle( double d )
		{
			QString s;
			s.sprintf( ROT_ACCURACY, d );
			ui.angle->setText( s );
			ui.angle->setCursorPosition(0);
		}
		void setFlX( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.flx->setText( s );
			ui.flx->setCursorPosition(0);
		}
		void setFlY( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.fly->setText( s );
			ui.fly->setCursorPosition(0);
		}
		void setSkew( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.skew->setText( s );
			ui.skew->setCursorPosition(0);
		}
		void setPX( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.px->setText( s );
			ui.px->setCursorPosition(0);
		}
		void setPY( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.py->setText( s );
			ui.py->setCursorPosition(0);
		}
		void setR00( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.r00->setText( s );
			ui.r00->setCursorPosition(0);
		}
		void setR01( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.r01->setText( s );
			ui.r01->setCursorPosition(0);
		}
		void setR02( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.r02->setText( s );
			ui.r02->setCursorPosition(0);
		}
		void setR10( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.r10->setText( s );
			ui.r10->setCursorPosition(0);
		}
		void setR11( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.r11->setText( s );
			ui.r11->setCursorPosition(0);
		}
		void setR12( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.r12->setText( s );
			ui.r12->setCursorPosition(0);
		}
		void setR20( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.r20->setText( s );
			ui.r20->setCursorPosition(0);
		}
		void setR21( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.r21->setText( s );
			ui.r21->setCursorPosition(0);
		}
		void setR22( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.r22->setText( s );
			ui.r22->setCursorPosition(0);
		}
	private:
		Ui::CameraWidgetBase ui;
		void beautifyLineEdit(QLineEdit* l);
};

#undef ACCURACY
#undef ROT_ACCURACY
#undef POS_ACCURACY

#endif

