

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#include "camparamwidget.h"

#include <QDoubleValidator>

CamParamWidget::CamParamWidget( QWidget* parent )
		: QWidget( parent )
{
	ui.setupUi( this );
	ui.flEdit->setValidator( new QDoubleValidator( 0, 180.0, 4 , ui.flEdit ) );
	ui.flEdit->setText( "1.0" );

	ui.arEdit->setValidator( new QDoubleValidator( 0, 10.0, 4 , ui.arEdit ) );
	ui.arEdit->setText( "1.0" );

	ui.skewEdit->setValidator( new QDoubleValidator( 0, 10.0, 4 , ui.skewEdit ) );
	ui.skewEdit->setText( "0.0" );

	ui.ppxEdit->setValidator( new QDoubleValidator( -10000, 10000.0, 4 , ui.ppxEdit ) );
	ui.ppxEdit->setText( "0.0" );

	ui.ppyEdit->setValidator( new QDoubleValidator( -10000, 10000.0, 4 , ui.ppyEdit ) );
	ui.ppyEdit->setText( "0.0" );

	ui.flPM->setValidator( new QDoubleValidator( 0.01, 10.0, 4 , ui.flPM ) );
	ui.flPM->setText( "3.0" );

	ui.arPM->setValidator( new QDoubleValidator( 0.01, 10.0, 4 , ui.arPM ) );
	ui.arPM->setText( "0.1" );

	ui.skewPM->setValidator( new QDoubleValidator( 0.01, 10.0, 4 , ui.skewPM ) );
	ui.skewPM->setText( "0.001" );

	ui.ppxPM->setValidator( new QDoubleValidator( 0.01, 10.0, 4 , ui.ppxPM ) );
	ui.ppxPM->setText( "0.1" );

	ui.ppyPM->setValidator( new QDoubleValidator( 0.01, 10.0, 4 , ui.ppyPM ) );
	ui.ppyPM->setText( "0.1" );
}

CamParamWidget::~CamParamWidget()
{
}

void CamParamWidget::enable( CALIBRATION_ENTITY what, bool yes, bool range )
{
	switch ( what )
	{
		case FL: ui.flEdit->setEnabled( yes ); ui.flPM->setEnabled( range ); break;
		case AR: ui.arEdit->setEnabled( yes ); ui.arPM->setEnabled( range ); break;
		case SKEW: ui.skewEdit->setEnabled( yes ); ui.skewPM->setEnabled( range ); break;
		case PPX: ui.ppxEdit->setEnabled( yes ); ui.ppxPM->setEnabled( range ); break;
		case PPY: ui.ppyEdit->setEnabled( yes ); ui.ppyPM->setEnabled( range ); break;
	}
}

double CamParamWidget::get( CALIBRATION_ENTITY what )
{
	switch ( what )
	{
		case FL: return ui.flEdit->text().toDouble();
		case AR: return ui.arEdit->text().toDouble();
		case SKEW: return ui.skewEdit->text().toDouble();
		case PPX: return ui.ppxEdit->text().toDouble();
		case PPY: return ui.ppyEdit->text().toDouble();
	}
	return 0.0;
}

double CamParamWidget::getRange( CALIBRATION_ENTITY what )
{
	switch ( what )
	{
		case FL: return ui.flPM->text().toDouble();
		case AR: return ui.arPM->text().toDouble();
		case SKEW: return ui.skewPM->text().toDouble();
		case PPX: return ui.ppxPM->text().toDouble();
		case PPY: return ui.ppyPM->text().toDouble();
	}
	return 0.0;
}

