

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef CONSTANTS_H
#define CONSTANTS_H

#include <vector>
#include <string>

namespace batch
{

	const char * const get_init_string();
	const char * const get_enum_string();

	enum Keyword
	{
		CreateViewRelations, MakePairs,
		CALCFEATURES, FindLines, CALCDESCR, CALCCORRS,
		TRACK,
		NORMALIZE, DENORMALIZE, FILTER, FilterAndMergeLines,
		CALCTENSOR, PROJRECONST, METRICRECONST, DEFAULTRECONST,
		GLOBALADJUSTMENT,

                HARRIS, CANNY, DOG, SCALE, SURF,

                SIFT, SURFD,

		SEQKNITTER, ARRKNITTER,

                KDTREE, MatchLines, FLANN,

		KLT_TRACKER,

		FEATUREID, MAXPOINTS, HOOD, MINDIST, MINSTRENGTH,
                MINFRACTION, SMOOTHS, IMAGES, HARRISTHRESH,
		DESCRID,

                MODE, SINGLE_BEST, RATIO_BEST, BBF_RATIO_BEST,
                DISTTHRESH, THRESHOLD, GOODRATIO,

		Focal_Length, Aspect_Ratio, Skew, Principal_Point_X, Principal_Point_Y,
		Free, Free_Const, Soft, Soft_Const, Hard, Hard_Const,

		Rotation, Angle_Axis, Location, Z,
		FL, AR, SKEW, PPX, PPY,
		dummy_k
	};
	Keyword strToEnum( const std::string& str );

} // namespace batch

#endif
