

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef SWITCH_H
#define SWITCH_H

#include <string>
#include <map>

namespace batch
{

	template < typename Class >
	class case_
	{
			typedef void ( Class::*function )( void );
		public:
			case_() : case_str( "undefined" ), funct( 0 ) {}
			case_( std::string s, function f ) : case_str( s ), funct( f ) {}
			operator std::string() { return case_str; }
			operator function() { return funct; }
		private:
			std::string case_str;
			function funct;
	};

	template < typename Class >
	class switch_
	{
			typedef void ( Class::*function )( void );
		public:
			switch_() {}

			switch_ operator() ( case_< Class > c )
			{
				case_map[c] = c;
				return *this;
			}

			void operator() ( Class* obj, const std::string& cond )
			{
				case_< Class > c = case_map[cond];
				if ( "undefined" == std::string( c ) )
					return;
				( obj->*c )();
			}
		private:
			std::map<std::string, case_< Class > > case_map;
	};

}

#endif
