

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#include "demowidget.h"
#include "mainwindow.h"

DemoWidget::DemoWidget( QObject * receiver )
		: _receiver( receiver )
{
	setupUi( this );
	connect( loadCamBtn, SIGNAL( clicked() ), _receiver, SLOT( slotLoadFromCamera() ) );
	connect( openImagesBtn, SIGNAL( clicked() ), _receiver, SLOT( openImageDir() ) );
	connect( openModelBtn, SIGNAL( clicked() ), _receiver, SLOT( open() ) );
	connect( saveModelBtn, SIGNAL( clicked() ), _receiver, SLOT( saveAs() ) );
	connect( to3DBtn, SIGNAL( clicked() ), _receiver, SLOT( to3D_2() ) );
	connect( stdBtn, SIGNAL( clicked() ), _receiver, SLOT( slotStandard() ) );
	connect( resetBtn, SIGNAL( clicked() ), _receiver, SLOT( slotReset() ) );
	connect( aboutButton, SIGNAL( clicked() ), _receiver, SLOT( slotShowAboutBox() ) );

	MainWindow* mainwin = qobject_cast<MainWindow*>( receiver );
	mainwin->setSimpleSaving( true );
	mainwin->setEmbedImages( /*false*/true );
}
