

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ERRORWIDGET_H
#define ERRORWIDGET_H

#include <QWidget>

#include <vector>
using namespace std;

#define ACCURACY "%.8f"

#include "ui_errorwidgetbase.h"

class QGraphicsView;
class QGraphicsScene;

class ErrorWidget : public QWidget
{
		Q_OBJECT

	public:
		ErrorWidget( const QString& title, QWidget* parent = 0 );
		~ErrorWidget();

		void setSum( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.sum->setText( s );
		}
		void setMin( double d )
		{
			minErr = d;
			QString s;
			s.sprintf( ACCURACY, d );
			ui.min->setText( s );
		}
		void setMax( double d )
		{
			maxErr = d;
			QString s;
			s.sprintf( ACCURACY, d );
			ui.max->setText( s );
		}
		void setAvg( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.avg->setText( s );
		}
		void setVar( double d )
		{
			QString s;
			s.sprintf( ACCURACY, d );
			ui.var->setText( s );
		}
		void drawErrors( vector<double> &err );

	private:
		double minErr;
		double maxErr;

		QGraphicsView* grview;
		QGraphicsScene* grscene;
		Ui::ErrorWidgetBase ui;
};

#undef ACCURACY

#endif

