

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef ITEM2D_H
#define ITEM2D_H

#include <QtCore/QPointF>
#include <QtCore/QSizeF>
#include <QtCore/QRectF>

class QGLWidget;

class Item2d
{
	public:
		Item2d() : position( 0, 0 ), size( 0, 0 ) {}
		virtual ~Item2d() {}

		double x() const { return position.x(); }
		double y() const { return position.y(); }
		void setPosition( const QPointF& pos ) { position = pos; }
		const QPointF& getPosition() const { return position; }
		double width() const { return size.width(); }
		double height() const { return size.height(); }
		const QSizeF& getSize() const { return size; }
		QRectF rect() const { return QRectF( position, size ); }

		virtual void paint() const = 0;

	protected:
		QPointF position;
		QSizeF size;
};

#endif // ITEM2D_H
