

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef NVIEWLIST_H
#define NVIEWLIST_H

#include <QStandardItem>

#include <adrcore/types/nview.h>

using namespace adore::core;

#include <QTreeView>

class QStandardItemModel;

class NViewList : public QTreeView
{
		Q_OBJECT
	public:
		NViewList( QWidget * parent = 0 );

		NView* newRow( const QString& label1, NView* nv );
		NView* newRow( NView* parent, NView* below, const QString& label1, NView* nv );
		NView* newRow( NView* parent, const QString& label1, NView* nv );
		NView* selectFirst();
		void deselect();
		void clear();

	signals:
		void sigItemSelected( NView* nv );
		void sigItemDoubleClicked( NView* nv );
	private slots:
		void slotItemDoubleClicked( const QModelIndex & index );

	private:
		class NViewListItem : public QStandardItem
		{
			public:
				NViewListItem( const QString& label1, NView* nv )
						: QStandardItem( label1 ), nview( nv ) { setEditable( false ); }
				NView* getNView()const { return nview; }
			private:
				NView* nview;
		};

		void setupHeader( int vcnt );
		QList<QStandardItem*> makeRow( const QString & label1, NView * nv )const;
		QStandardItemModel* model;
		map<NView *, QStandardItem*> nvToItem;

		void currentChanged( const QModelIndex& current,
		                     const QModelIndex& previous );
};

#endif
