

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#include "nviewstatistics.h"

#include <adrcore/types/nview.h>

#include <boost/cstdint.hpp>

#include <cassert>

using namespace adore::core;

NViewStatistics::NViewStatistics(QWidget *parent) :
    QWidget(parent){
    setupUi(this);
}

void NViewStatistics::setData(adore::core::NView* nview)
{
	assert(nview);
	
	editNumOfViews->setText(QString::number(nview->getNumViews()));
	editNumOfCorrs->setText(QString::number(nview->getNumPointCorrs()));
	featureTable->clear();
	featureTable->setColumnCount(2);
	featureTable->setRowCount(nview->getNumViews());

	QStringList labels(tr("View")); labels << tr("Number of feature points");
	featureTable->setHorizontalHeaderLabels(labels);
	int i = 0;
	for(NView::ViewIterator vit = nview->getViewsBegin(); vit != nview->getViewsEnd(); ++vit, ++i)
	{
		QString ptr = QString::number(reinterpret_cast<boost::uint64_t>(*vit), 16);

		QTableWidgetItem * item = new QTableWidgetItem(ptr);
		featureTable->setItem(i, 0, item);
		item->setFlags(Qt::ItemIsEnabled | Qt::ItemIsSelectable);
		item = new QTableWidgetItem(QString::number((*vit)->getNumFeaturePoints()));
		featureTable->setItem(i, 1, item);
	}
	featureTable->resizeColumnsToContents();
}
