

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef OBJECTSELECTDIALOG_H
#define OBJECTSELECTDIALOG_H

#include <QDialog>

#include <string>
#include <vector>

#include "ui_objectselect.h"

class ObjectSelectDialog : public QDialog, private Ui::ObjectSelect
{
		Q_OBJECT
	public:
		ObjectSelectDialog() { setupUi( this ); }

		void setNames( std::vector<std::string> names )
		{
			std::vector<std::string>::iterator myit = names.begin();
			for ( ; myit != names.end(); ++myit ) listBox->addItem( QString::fromStdString( *myit ) );
			listBox->setCurrentItem( listBox->item( 0 ) );
		}

		std::string getSelected() { return listBox->currentItem()->text().toStdString(); }
	private slots:
		void canceled()
		{
			listBox->clearSelection();
			done( QDialog::Rejected );
		}
};


#endif
