

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#include "pushbuttongl.h"

PushButtonGL::PushButtonGL(const QString& text) :
		m_label(text)
{
}

void PushButtonGL::initialize(QGLWidget* binder)
{
	m_label.buildTexture(0xff00aa40, binder);
	size = QSizeF(m_label.width(), m_label.height());
}

void PushButtonGL::cleanup()
{
	m_label.releaseTexture();
}

void PushButtonGL::paint() const
{
	glTranslated(position.x(), position.y(), 0.0);
	m_label.draw();
	glTranslated(-position.x(), -position.y(), 0.0);
}

void PushButtonGL::click(double, double)
{
	emit clicked(this);
}
