

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef SPLITTER_H
#define SPLITTER_H

#include <QtGui/QSplitterHandle>
#include <QtGui/QSplitter>
#include <QtGui/QBrush>

class QToolButton;

class SplitterHandle : public QSplitterHandle
{
	Q_OBJECT
public:
	enum { GoodThickness = 14 };
	SplitterHandle(Qt::Orientation orientation, QSplitter * parent, int thickness = GoodThickness);

	QSize sizeHint () const;

signals:
	void springLeft();
	void springRight();
	void springDown();
	void springUp();

protected:
	void paintEvent(QPaintEvent *event);

private:
	QToolButton * m_btnl, * m_btnr;
	QBrush m_brush;

private slots:
	void leftClicked();
	void rightClicked();
	void downClicked();
	void upClicked();
};

class Splitter : public QSplitter
{
	Q_OBJECT
public:
	Splitter(Qt::Orientation orientation, QWidget * parent = NULL);

protected:
	QSplitterHandle * createHandle();

private slots:
	void leftClicked();
	void rightClicked();
	void downClicked();
	void upClicked();
};

#endif // SPLITTER_H
